#include "demo.h"
              

static struct interface {
      APTR app;  
      APTR window;
      APTR label1;
      APTR string1;
      APTR gauge1;
      APTR slider1;
      APTR slider2;
      APTR button1;

} App;

int main(int argc,char *argv[])
{
        /* Check for and then initiate MUI */
        init();
        
        /* Below defines the interface */
        
        /* Create the application object */
           App.app = ApplicationObject,
                /* Default information */
                MUIA_Application_Title      , "MUI_Example3",
                MUIA_Application_Version    , "$VER: Demo 1.0 (22.10.97)",
                MUIA_Application_Copyright  , "1997, Dr. Karl Bellve",
                MUIA_Application_Author     , "Dr. Karl Bellve",
                MUIA_Application_Description, "Show a MUI program.",
                MUIA_Application_Base       , "DEMO",

                /* Define a window object*/
                SubWindow, App.window = WindowObject,
                        /* Put a title on your window */
                        MUIA_Window_Title, "MUI_Example3",
                        /* Give your window a unique ID */
                        MUIA_Window_ID   , MAKE_ID('D','E','M','O'),
                        /* Define what is inside your window */
                        WindowContents, HGroup, /* Everything inside this group will be layed out horizontally */
                                Child, App.slider1               = SliderObject, SliderFrame, MUIA_Numeric_Value, 0, MUIA_Slider_Max, 1000, MUIA_Slider_Horiz, FALSE, End,
                                Child, VGroup, /* Everything inside this group will be layed out vertically */
                                        Child, App.label1        = Label ("\33cI am a Label"),
                                        Child, App.string1       = StringObject, StringFrame, MUIA_String_Accept, "0123456789", MUIA_String_Format, MUIV_String_Format_Center, MUIA_String_MaxLen, 4, MUIA_String_Integer, 0, End, 
                                        Child, App.gauge1        = GaugeObject, GaugeFrame, MUIA_Gauge_Horiz, TRUE, MUIA_Gauge_Max, 1000, MUIA_Numeric_Value, 0, MUIA_Gauge_InfoText, "Notification RULES!", End,
                                        Child, VSpace (0),
                                        Child, App.button1       = KeyButton("Reset",'r'),
                                        End,
                                Child, App.slider2               = SliderObject, SliderFrame, MUIA_Numeric_Value, 0, MUIA_Slider_Max, 1000, MUIA_Slider_Horiz, FALSE, MUIA_Numeric_Reverse, TRUE, End,
                                End,
                        End,
                End;

        /* Check to see if the interface was made, if it wasn't, exit */
        if (!App.app) fail(App.app,"Failed to create Application.");
        
        /* Shut down the application when the user closes the window, connect the close window gadget to make it */
        /* return MUIV_Application_ReturnID_Quit to quit main loop */
        DoMethod(App.window,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,App.app,2,MUIM_Application_ReturnID,MUIV_Application_ReturnID_Quit);

        /* Add my objects to a cyclechain so a user can use the tab key to cycle through my app */
        set(App.label1,       MUIA_CycleChain,TRUE);
        set(App.string1,      MUIA_CycleChain,TRUE);
        set(App.slider1,      MUIA_CycleChain,TRUE);
        set(App.gauge1,       MUIA_CycleChain,TRUE);
        set(App.slider2,      MUIA_CycleChain,TRUE);
        set(App.button1,      MUIA_CycleChain,TRUE);
        
        
        /* Help text for bubbles, normally this should be localized */
        set(App.label1,   MUIA_ShortHelp,"I am a just a label");
        set(App.string1,  MUIA_ShortHelp,"I am a string gadget but I only accept digits.");
        set(App.slider1,  MUIA_ShortHelp,"I am a slider, move me.");
        set(App.button1,  MUIA_ShortHelp,"Push me to reset everything.");
        set(App.slider2,  MUIA_ShortHelp,"Don't believe the other slider, I am the real thing.");
        set(App.gauge1,   MUIA_ShortHelp,"Am I full yet?");
                
        
        /* String object notifies Label Object of new contents */
        DoMethod(App.string1,MUIM_Notify, MUIA_String_Acknowledge, MUIV_EveryTime,App.label1,3,MUIM_Set,MUIA_Text_Contents,MUIV_TriggerValue);         
        
        
        /* Slider object notifies String Object of new position and converts it to a string from an integer */
        /* use MUIA_Numeric_Value instead of MUIA_Slider_Value */
        DoMethod(App.slider1, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.string1, 4, MUIM_SetAsString, MUIA_String_Contents, "%ld", MUIV_TriggerValue);
        /* Slider object also notifies Label Object of new position and converts it to a string from an integer*/
        DoMethod(App.slider1, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.label1, 4, MUIM_SetAsString, MUIA_Text_Contents, "%ld", MUIV_TriggerValue);
        /* Slider object also notifies Gauge Object of new position */
        DoMethod(App.slider1, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.gauge1, 3, MUIM_Set, MUIA_Gauge_Current, MUIV_TriggerValue);
        
        /* set up notification for the other slider */
        /* Slider object also notifies the other Slider Object of new position */
        DoMethod(App.slider1, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.slider2, 3, MUIM_Set, MUIA_Numeric_Value, MUIV_TriggerValue);
       
        /* use MUIA_Numeric_Value instead of MUIA_Slider_Value */
        DoMethod(App.slider2, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.string1, 4, MUIM_SetAsString, MUIA_String_Contents, "%ld", MUIV_TriggerValue);
        /* Second Slider object also notifies Label Object of new position and converts it to a string from an integer*/
        DoMethod(App.slider2, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.label1, 4, MUIM_SetAsString, MUIA_Text_Contents, "%ld", MUIV_TriggerValue);       
        /* Second Slider object also notifies the other Slider Object of new position */
        DoMethod(App.slider2, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.slider1, 3, MUIM_Set, MUIA_Numeric_Value, MUIV_TriggerValue);
        /* Second Slider object notifies the Gauge object of new value */
        DoMethod(App.slider2, MUIM_Notify, MUIA_Numeric_Value, MUIV_EveryTime, App.gauge1, 3, MUIM_Set, MUIA_Gauge_Current, MUIV_TriggerValue);
        
        /* reset all the values when the button is pushed using notification */
        DoMethod(App.button1, MUIM_Notify, MUIA_Pressed, FALSE, App.string1, 3, MUIM_Set, MUIA_String_Integer, 0);
        DoMethod(App.button1, MUIM_Notify, MUIA_Pressed, FALSE, App.label1, 3, MUIM_Set, MUIA_Text_Contents, "0");
        
        /* This line relaces the following three lines */
        DoMethod(App.button1, MUIM_Notify, MUIA_Pressed, FALSE, App.gauge1, 7, MUIM_MultiSet, MUIA_Numeric_Value, 0, App.slider1,App.slider2,App.gauge1, NULL);
        //DoMethod(App.button1, MUIM_Notify, MUIA_Pressed, FALSE, App.slider1, 3, MUIM_Set, MUIA_Numeric_Value, 0);
        //DoMethod(App.button1, MUIM_Notify, MUIA_Pressed, FALSE, App.slider2, 3, MUIM_Set, MUIA_Numeric_Value, 0);
        //DoMethod(App.button1, MUIM_Notify, MUIA_Pressed, FALSE, App.gauge1, 3, MUIM_Set, MUIA_Numeric_Value, 0);
        

        /* I want my Label Object to center and make bold all text, I could have done this at object
           creation time, or I can do it here */
        set(App.label1, MUIA_Text_PreParse,"\33c\33b");

        /* Open the applications window */
        set(App.window,MUIA_Window_Open,TRUE);

        {
                ULONG sigs = 0;
                /* Check for user inputs */
                while (DoMethod(App.app,MUIM_Application_NewInput,&sigs) != MUIV_Application_ReturnID_Quit)
                {
                        if (sigs)
                        {        
                                sigs = Wait(sigs | SIGBREAKF_CTRL_C);
                                if (sigs & SIGBREAKF_CTRL_C) break;
                        }
                }
        }

        /* Close the applications window */
        set(App.window,MUIA_Window_Open,FALSE);

        /* Dispose of the interface */
        fail(App.app,NULL);
        
}

